<?php
/*
 * $Horde: kronolith/calendarprefs.php,v 1.05 2002/07/31 19:02:49 jvandal Exp $
 *
 * Copyright 2002 Joel Vandal <jvandal@infoteck.qc.ca>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

define('CALENDAR_EDIT',   1);
define('CALENDAR_SAVE',   2);
define('CALENDAR_DELETE', 3);
define('CALENDAR_ACCESS', 4);
define('KRONOLITH_BASE', dirname(__FILE__));
require_once KRONOLITH_BASE . '/lib/base.php';
require_once KRONOLITH_BASE . '/lib/Calendar.php';

include_once HORDE_BASE . '/lib/Perms.php' ;
include_once HORDE_BASE . '/lib/Group.php' ;

$_calendar = new Calendar();
$to_edit = null;
$onlynew = 0;
$actionID = Horde::getFormData('actionID', NOOP);

// handle clients without javascript
if ($actionID == NOOP) {
    if (isset($_POST['edit'])) {
        $actionID = CALENDAR_EDIT;
    } elseif (isset($_POST['save'])) {
        $actionID = CALENDAR_SAVE;
    } elseif (isset($_POST['delete'])) {
        $actionID = CALENDAR_DELETE;
    } elseif (isset($_POST['accesslist'])) {
        $actionID = CALENDAR_ACCESS;
    } elseif (isset($_POST['back'])) {
        header('Location: ' . Horde::applicationUrl('prefs.php', true));
        exit;
    }
}

/* Run through the action handlers */
switch ($actionID) {
 case CALENDAR_EDIT:
    $to_edit = Horde::getFormData('calendar');
    break;
    
 case CALENDAR_SAVE:
    $edit_calendar = Horde::getFormData('edit_calendar');
    $id = Horde::getFormData('id');
    
    if (!isset($edit_calendar) || $edit_calendar == '') {
	$edit_calendar = $_calendar->add();
	
	$groupid = md5(microtime()) ;
	
	$groups = &Group::singleton() ;
	$group = &$groups->newGroup($groupid) ;
	$groups->addGroup($group) ;
	
	$perms = &Perms::singleton() ;
	$perm  = &$perms->newPermission($groupid) ;
	$perm->addGroupPermission($group, _PERMS_SHOW, false);
	$perms->addPermission($perm) ;
	
	$_calendar->setValue('key', $groupid, $edit_calendar);
    }
    
    if (isset($id) && !empty($id)) {
        $_calendar->setValue('id', $id, $edit_calendar);
    } else {
	$notification->push(sprintf(_("The calendar name is empty."), $id), 'horde.error');
	break ;
    }
    
    $_calendar->setValue('type', Horde::getFormData('type'), $edit_calendar);
    $_calendar->setValue('description', Horde::getFormData('description'), $edit_calendar);
    $_calendar->save();
    
    $groupid = $_calendar->getValue('key', $edit_calendar) ;
    $grouptype = Horde::getFormData('type') ;
    
    if ($edit_calendar > 0) {
	$calendar->deleteCalendar($groupid) ;
	$calendar->saveCalendar($groupid, $id, $grouptype ) ;
    }
    
    unset($to_edit);
    $notification->push(sprintf(_("The calendar \"%s\" has been saved."), $id), 'horde.success');
    break;
    
 case CALENDAR_DELETE:
    $to_delete = Horde::getFormData('edit_calendar');
    
    if ($to_delete == 0) {
	$notification->push(sprintf(_("The calendar \"%s\" cannot be deleted."), $id), 'horde.warning');
	break ;
    }
    
    $groupid = $_calendar->getValue('key', $to_delete) ;
    if (isset($to_delete)) {
	$deleted_calendar = $_calendar->delete($to_delete);
	
	$groups = &Group::singleton() ;
	$group = &$groups->getGroup($groupid) ;
	$groups->removeGroup($group) ;
	
	$perms = &Perms::singleton() ;
	$perm  = &$perms->getPermission($groupid) ;
	$perms->removePermission($perm) ;
	
	$notification->push(sprintf(_("The calendar \"%s\" has been deleted."), $deleted_calendar[0]['id']), 'horde.success');
    } else {
	$notification->push(_("You must select an calendar to be deleted."), 'horde.warning');
    }
    break;
    
 case CALENDAR_ACCESS:
    $edit_calendar = Horde::getFormData('edit_calendar');
    $id = Horde::getFormData('id');
    $type = Horde::getFormData('type');
    
    if ($type == 1) {
        header('Location: ' . Horde::applicationUrl('membersprefs.php?edit_calendar=' . $edit_calendar, true)) ;
    }
    
    break ;
}

$title = _("Calendars");
$js_onLoad = null;

$_calendars = $_calendar->getAll('id');

require KRONOLITH_TEMPLATES . '/common-header.inc';

require KRONOLITH_BASE . '/menu.php';
require KRONOLITH_BASE . '/status.php';

require KRONOLITH_TEMPLATES . '/calendar/javascript.inc';
require KRONOLITH_TEMPLATES . '/calendar/manage.inc';

$registry->shutdown();

require KRONOLITH_TEMPLATES . '/common-footer.inc';

?>

