<?php
/*
 * $Horde: kronolith/membersprefs.php,v 1.02 2002/07/31 19:03:15 jvandal Exp $
 *
 * Copyright 2002 Joel Vandal <jvandal@infoteck.qc.ca>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

define('MEMBERS_EDIT',   1);
define('MEMBERS_SAVE',   2);
define('MEMBERS_DELETE', 3);
define('MEMBERS_ACCESS', 4);
define('KRONOLITH_BASE', dirname(__FILE__));
require_once KRONOLITH_BASE . '/lib/base.php';
require_once KRONOLITH_BASE . '/lib/Members.php';
require_once KRONOLITH_BASE . '/lib/Calendar.php';

require_once HORDE_BASE . '/lib/Perms.php' ;
require_once HORDE_BASE . '/lib/Group.php' ;

$_calendar = new Calendar();

$to_edit = null;
$onlynew = 0;
$actionID = Horde::getFormData('actionID', NOOP);
$edit_calendar = Horde::getFormData('edit_calendar');

$_member = new Members($edit_calendar);

global $prefs ;

$calx = @unserialize($prefs->getValue('calendars')) ;
$groupid = $calx[$edit_calendar]['key'];

// handle clients without javascript
if ($actionID == NOOP) {
    if (isset($_POST['edit'])) {
        $actionID = MEMBERS_EDIT;
    } elseif (isset($_POST['save'])) {
        $actionID = MEMBERS_SAVE;
    } elseif (isset($_POST['delete'])) {
        $actionID = MEMBERS_DELETE;
    } elseif (isset($_POST['back'])) {
        header('Location: ' . Horde::applicationUrl('prefs.php', true));
        exit;
    }
}

/* Run through the action handlers */
switch ($actionID) {
 case MEMBERS_EDIT:
     $to_edit = Horde::getFormData('member');
     break;

 case MEMBERS_SAVE:
     $edit_member = Horde::getFormData('edit_member');
     $edit_calendar = Horde::getFormData('edit_calendar');
     $id = Horde::getFormData('id');
    
    if (!isset($edit_member) || $edit_member == '') {
        $edit_member = $_member->add();
    }

     if (isset($id) && !empty($id)) {
        $_member->setValue('id', $id, $edit_member);
     } else {
	 $notification->push(sprintf(_("The member name is empty."), $id), 'horde.warning');
	 break ;
     }

     $_member->setValue('name',  Horde::getFormData('name'), $edit_member);
     $_member->setValue('fields', Horde::getFormData('fields'), $edit_member);

    
    $_calendar->setValue('member', serialize($_member->members), $edit_calendar);
    $_calendar->save();
    
    $userid = Horde::getFormData('id') ;
    
    $groups = &Group::singleton() ;
    $group = &$groups->getGroup($groupid);
    $group->addUser($userid) ;
    
    $perms = &Perms::singleton() ;
    $perm  = &$perms->getPermission($groupid);

    $perm->removeUserPermission($userid, _PERMS_NONE, false);
    $perm->addUserPermission($userid, _PERMS_SHOW, false);

    $p = Horde::getFormData('fields') ;
    
    foreach ($p as $index => $field) {
	switch($field) {
	 case 'show' :
	    $perm->addUserPermission($userid, _PERMS_SHOW, false);
	    break ;
	 case 'read' : 
	    $perm->addUserPermission($userid, _PERMS_READ, false);
	    break ;
	 case 'edit' : 
	    $perm->addUserPermission($userid, _PERMS_EDIT, false);
	    break ;
	 case 'delete' :
	    $perm->addUserPermission($userid, _PERMS_DELETE, false);
	    break ;
	}
    }
    $perm->save() ;
    
     unset($to_edit);
     $notification->push(sprintf(_("The member \"%s\" has been saved."), $id), 'horde.success');

     break;

 case MEMBERS_DELETE:
     $to_delete = Horde::getFormData('edit_member');
     if (isset($to_delete)) {
	 
	 $groups = &Group::singleton() ;
	 $group = &$groups->getGroup($groupid) ;
	 $group->removeUser($_member->getValue('id', $to_delete)) ;
	 
         $deleted_member = $_member->delete($to_delete);

	 $_calendar->setValue('member', serialize($_member->members), $edit_calendar);
	 $_calendar->save();
	 
         $notification->push(sprintf(_("The member \"%s\" has been deleted."), $deleted_member[0]['id']), 'horde.success');
     } else {
         $notification->push(_("You must select an member to be deleted."), 'horde.warning');
     }
     break;
 
}

$title = _("Members List");
$js_onLoad = null;

$_members = $_member->getAll('id');

$fieldsList['show'] = 0 ;
$fieldsList['read'] = 1 ;
$fieldsList['edit'] = 2 ;
$fieldsList['delete'] = 3 ;

$calx = @unserialize($_calendar->getValue('calendars'));
$id = $calx[$edit_calendar]['id'] ;

require KRONOLITH_TEMPLATES . '/common-header.inc';

require KRONOLITH_BASE . '/menu.php';
require KRONOLITH_BASE . '/status.php';

require KRONOLITH_TEMPLATES . '/calendar/members_javascript.inc';
require KRONOLITH_TEMPLATES . '/calendar/members_manage.inc';

$registry->shutdown();

require KRONOLITH_TEMPLATES . '/common-footer.inc';

?>
